/*
Azonos számjegyek
*/

#include <iostream>
#include <fstream>

using namespace std;

int const maxDim = 10000;

ifstream fin("azonos3.in");

int lepesekSzama = 0;

void beOlvas(int &a, int &b){

    fin >> a;
	fin >> b;
	cout << "a = " << a << endl;
	cout << "b = " << b << endl;	

}

// V1 - O(k)

void azonos_V1(int a, int b, int & k, int sor[]){

int i;
    k = 0; 
	if(a < 10){					           // a-nak egy számjegye van
    	i = 1;
    	sor[i] = a;
    	while(sor[i] < 9 && sor[i] < b){   // ha a és b < 10, a sorozat elemei
            i++;
    		sor[i] = sor[i-1] + 1;
    		lepesekSzama++;
    	}
    	k = i;					           // van k elemünk
	}

    int kulonbseg = 11; 	// két egymás után következő, 100-nál kseebb, azonos számjegyekből álló szám kulonbsege
    int tag = 0; 
    while(tag < b){
        tag += kulonbseg;
        lepesekSzama++;
        if(tag % 10 == 0){ 	// pl. 99 + 11 = 110 - vagyis a kulonbseg ezután nagyobb lesz (111)
            kulonbseg = kulonbseg * 10 + 1;
            tag++;			// tehát 110-hez hozzáadunk 1-et
        }
        if(tag >= a && tag <= b){	// csak akkor őrizzük meg, ha >= a és <= b
        	k++;
        	sor[k] = tag;
        }
    }
}

// V2

int szjSzama(int a){
// az a szamjegyeinek darabszáma

    int db = 0;
    do{
        db++;
        a /= 10;
        lepesekSzama++;
    }while(a > 0);
    return db;
}

int elem(int aktSzjSzam, int szj){
// generéljuk "tag"-ot, amelynek aktSzjSzam azonos számjegye van 

    int tag = 0;
    for(int i = 1; i <= aktSzjSzam; i++){
        tag = tag * 10 + szj;
        lepesekSzama++;
    }
    
    return tag;
}

void azonos_V2(int a, int b, int & k, int sor[]){
// generáljuk az a és b között levő, azonos számjegyekből álló számokat

    int szjSzamaA = szjSzama(a);  
    int szjSzamaB = szjSzama(b);  
    int szj = 1;
    
    k = 0;
    int tag = elem(szjSzamaA, szj);      // tag szjSzamaA 1-esből áll
    
    while(tag < a){                          
        szj++;
        tag = elem(szjSzamaA, szj);      // ezt a tagot később mentjük el
        lepesekSzama++;
    }
    
    int aktSzjSzam = szjSzamaA;                  
    while(aktSzjSzam <= szjSzamaB || tag <= b){   
        while(szj < 9 && tag <= b) {
            k++;
            sor[k] = tag;
            szj++;
            tag = elem(aktSzjSzam, szj);
            lepesekSzama++;
        }
        aktSzjSzam++;                   
        szj = 0;                  // az elso számjegy 1 lesz a ciklus elején
    }
}

// V3

void azonos_V3(int a, int b, int & k, int sor[]){
// a és b között található azonos számjegyekből épített számok

    int szjSzamaA = szjSzama(a);  
    int szjSzamaB = szjSzama(b);  
    int tag;
    
    k = 0;
    
    int aktSzjSzam = szjSzamaA;                  
    while(aktSzjSzam <= szjSzamaB){  
        int szj = 1;
        while(szj <= 9) {
            tag = elem(aktSzjSzam, szj);
            if(tag >= a and tag <= b){
                k++;
                sor[k] = tag; 
            }
            szj++;
            lepesekSzama++;
        }
        aktSzjSzam++;                   
    }
}

// V4

bool ok(int szam){
// eldöntjük, hogy "szam" azonos számjegyekből áll vagy sem

    int szj = szam % 10;                // első szj
    szam /= 10;
    while(szam > 0 && szam % 10 == szj){// az aktuális szj-t hasonlítjuk az elsővel 
        szam /= 10;
        lepesekSzama++;
    }   
        
    return szam == 0;                     // sikerült osztani végig 
}

void azonos_V4(int a, int b, int & k, int sor[]){
// generálunk minden számot a-tól b-ig és ellenőrizzük mindegyiket

    k = 0;
    for(int szam = a; szam <= b; szam++){
        if(ok(szam)){
            k++;
            sor[k] = szam;
        }
        lepesekSzama++;
    }
}

void kiIrEredmeny(int a, int b, int k, int sor[]){

	if(k == 0)
		cout << "Nincs";
	else{
		cout << "k = " << k << endl;
		cout << "Azonos szamjegyeket tarolnak: " << endl;
		for(int i = 1; i <= k; i++)
			cout << sor[i] << " ";
	 	cout << endl;
	}
}

void azonosSzamjegyek(int a, int b, int &k, int x[]){ 
// egy számjegyből álló elemek, utána 11 többszörösei

    k = 0; 
    for(int i = a; ((i < 10) && (i <= b)); i++){ 
        lepesekSzama++;
        x[++k] = i; 
    } 
    int akt = 11; 
    int leptek = 11; 
    while(akt <= b){ 
        lepesekSzama++;
        if(akt >= a) 
            x[++k] = akt; 
        akt = akt + leptek; 
        if(akt > 9 * leptek){ 
            akt = leptek * 10 + 1; 
            leptek = akt; 
        } 
    } 
}

int main(){

int a, b, k;
int sor[maxDim];

    beOlvas(a, b);

    azonos_V1(a, b, k, sor);
    kiIrEredmeny(a, b, k, sor);
    cout << "Vegrehajtottunk " << lepesekSzama << " lepest." << endl;

    lepesekSzama = 0;
    azonos_V2(a, b, k, sor);
    kiIrEredmeny(a, b, k, sor);    
    cout << "Vegrehajtottunk " << lepesekSzama << " lepest." << endl;

    lepesekSzama = 0;
    azonos_V3(a, b, k, sor);
    kiIrEredmeny(a, b, k, sor);    
    cout << "Vegrehajtottunk " << lepesekSzama << " lepest." << endl;

    lepesekSzama = 0;
    azonos_V4(a, b, k, sor);
    kiIrEredmeny(a, b, k, sor);    
    cout << "Vegrehajtottunk " << lepesekSzama << " lepest." << endl;

    lepesekSzama = 0;
    azonosSzamjegyek(a, b, k, sor); // V1 tömörebben
    kiIrEredmeny(a, b, k, sor);    
    cout << "Vegrehajtottunk " << lepesekSzama << " lepest." << endl;
}
