#include <iostream>
#include <fstream>

using namespace std;

ifstream fin("baratok_2.in");

const int maxDim = 700;

struct par{
  	int x, y; 
};

void beolvas(int & n, int & p, par szemely[]){
// beolvasas

  	fin >> n;					   		        // szemelyek szama 
  	fin >> p;                      		 		// parok szama 
  	for(int i = 1; i <= p; i++)
   		fin >> szemely[i].x >> szemely[i].y;	// parok
}

void kiIrBemenet(int n, int p, par szemely[]){
// a statistikaban talalhato adatok kiirasa

  	cout << "n = " << n << endl;   
  	cout << "p = " << p << endl;   
  	for(int i = 1; i <= p; i++)
    	cout << szemely[i].x << " " << szemely[i].y << endl;
  	cout << endl;
}

void kiIrSorozat(int n, int x[]){
// sorozat kiirasa

  for(int i = 1; i <= n; i++)
    cout << x[i] << " ";
  cout << endl << endl;
}

void maxBaratok_a(int n, int p, par szemely[], int & k, int maxBaratok[], int baratokSzama[]){
// a legtobb barattal rendelkezo szemelyek sorozatanak meghatarozasa

	for(int i = 1; i <= n; i++) 		     // meg nem fedeztunk fel egy baratot sem
   		baratokSzama[i] = 0;
  	
  	for(int i = 1; i <= p; i++) 		 
   		baratokSzama[szemely[i].x]++;       // az x megjelenik, mint a szampar elso eleme, tehat van (meg) egy baratja

  	//cout << "Bejelentett baratok szama, szemelyenkent: " << endl;
  	//kiIrSorozat(n, baratokSzama);
  	// meghatarozzuk a baratokSzama tomb minden olyan indexet, ahol a tomb maximumerteke talalhato
  	k = 1;
  	maxBaratok[k] = 1;						// kezdoertek
  	int m = baratokSzama[1];				// m = aktualis maximum
	for(int i = 2; i <= n; i++){
   		if(baratokSzama[i] > m){			// talaltunk m-nel nagyobb baratszamot
   			m = baratokSzama[i];			// aktualizaljuk m-et
   			k = 1;							// m-nek ez az elso elofordulasa
   			maxBaratok[k] = i;				// megjegyezzuk a szemely indexet
   		} 
   		else
   			if(baratokSzama[i] == m){		// talaltunk m-mel egyenlo baratszamot
   				k++;
   				maxBaratok[k] = i;
   			}
  	}
}

int parokSzama_b(int n, int p, par szemely[], int baratokSzama[]){
// parok, akik kolcsonosen egymast jeloltek meg baratjukkent

int k = 0;
bool volt[maxDim];
int baratokSzamaY[maxDim];

	for(int i = 1; i <= n; i++) 		     // meg nem fedeztunk fel egy baratot sem
   		baratokSzamaY[i] = 0;
  	
  	for(int i = 1; i <= p; i++) 		 
   		baratokSzamaY[szemely[i].y]++;       // a szemely[i].y megjelenik, mint a szampar masodik eleme, tehat van (meg) egy baratja

   	//kiIrSorozat(n, baratokSzamaY);

  	for(int i = 1; i <= n; i++)
   		volt[i] = false;					// meg senkit nem dolgoztunk fel
	
  	for(int i = 1; i <= p; i++){			// a szamparokat jarjuk be
   		for(int j = i + 1; j <= p; j++){
			if(!volt[szemely[i].x] && !volt[szemely[j].y])		
											// sem szemely[i].x, sem szemely[j].y nincsenek feldolgozva
     			if((baratokSzama[szemely[i].x] == 1) && (baratokSzamaY[szemely[j].y] == 1) 
     				// szemely[i].x-nek es szemely[j].y-nak is csak egy baratja van
       				&& (baratokSzama[szemely[i].y] == 1) && (baratokSzamaY[szemely[j].x] == 1)
       				// szemely[i].y-nak es szemely[j].x-nek is csak egy baratja van
       				&& (szemely[i].x == szemely[j].y) && (szemely[i].y == szemely[j].x)){
					// szemely[i].x szemely[j].y-t, szemely[i].y szemely[j].x-et jelolte meg baratkent
     				k++;
     				volt[szemely[i].x] = true;			// szemely[i].x-et felvettuk a nyilvantartasba
     				volt[szemely[i].y] = true;			// szemely[i].y-t felvettuk a nyilvantartasba
     			}
   		}
  	}
	return k;
}

void mind_c(int n, int p, par szemely[], int & t, int mind[]){
// letrehozzuk a statisztikaban szereplo szemelyek halmazat

bool megjelent[maxDim];

  	for(int i = 1; i <= n; i++){				// kezdoertek
   		megjelent[i] = false;
  	}
	
	for(int i = 1; i <= p; i++){				// aktualizalas
   		megjelent[szemely[i].x] = true;
   		megjelent[szemely[i].y] = true;
	}
	
	t = 0;
	for(int i = 1; i <= n; i++){
		if(megjelent[i]){
			t++;
			mind[t] = i;
		}
	}
}

void halmazzaAlakit(int & n, int s[]){
// halmazza alakitjuk az n elemu s tombot 
	
	int i = 1;
	while(i < n){
		int j = i + 1;
		while((j <= n) && (s[i] != s[j]))
			j++;
		if(j <= n){
			s[i] = s[n];
			n--;
		} else
			i++;
	}
}

void csoportosit(int p, par szemely[], int & csoportokSzama, int hossz[], int cs[][maxDim]){
// 

int seged[2];							// egy adott csoportban talalhato szemelyek darabszama egy aktualis szamparban
bool megvan;

	for(int i = 1; i <= p; i++)			// ha minden egyes szemely egy-egy csoportot alkotna, a csoportok szama = p
		hossz[i] = 0;					// egyelore minden csoport ures

	csoportokSzama = 0;
	for(int i = 1; i <= p; i++){		// minden part feldolgozunk 
		int k = 0;						// a seged tomb elemeinek szama
		
		for(int j = 1; j <= csoportokSzama; j++){	
										// bejarjuk a letezo csoportokat
			int q = 1;					// q-val bejarjuk a j. csoportot
			megvan = false;	
			while(!megvan && q <= hossz[j]){
				if((szemely[i].x == cs[j][q]) || (szemely[i].y == cs[j][q])){
										// ha szemely[i].x vagy szemely[i].y a j. csoporthoz tartozik
					k++;				// no a seged tomb elemeinek szama
					seged[k] = j;		// taroljuk a csoport indexet ahol megtalaltuk valamelyiket az aktualis szamparbol
					megvan = true;		
				}
				q++;					// a j. csoport kovetkezo eleme
			}
		}
    	if(k == 0){						// ha nem talaltuk meg egyiket sem 
			csoportokSzama++;			// uj csoportot inditunk
			hossz[csoportokSzama] = 1;					
			cs[csoportokSzama][hossz[csoportokSzama]] = szemely[i].x;	
										// elhelyezzuk az uj csoportba szemely[i].x-et
			hossz[csoportokSzama]++;				
			cs[csoportokSzama][hossz[csoportokSzama]] = szemely[i].y;
										// es szemely[i].y-t 
		}
    	else
    		if(k == 1) {				// ha legalabb egyiket megtalaltuk
				hossz[seged[1]]++;		// no annak a csoportnak a merete, amit elmentettunk seged[1]-be 
				cs[seged[1]][hossz[seged[1]]]= szemely[i].x;
										// ebbe a csoportba elhelyezzuk szemely[i].x-et
				hossz[seged[1]]++;
				cs[seged[1]][hossz[seged[1]]] = szemely[i].y;	
										// es szemely[i].y-t
			}
			else
    			if(k == 2) {			// ha az egyiket egy bizonyos csoportban, a masikat egy masikban talaltuk meg
					for(int w = 1; w <= hossz[seged[2]]; w++){
										// bejarjuk a seged[2] indexu csoportot
            			hossz[seged[1]]++;	
            							// a seged[1] indexu csoportba elhelyezzuk a seged[2] indexu csoport elemeit
            			cs[seged[1]][hossz[seged[1]]] = cs[seged[2]][w];
            		}
					if(seged[2] == csoportokSzama) 				
										// ha a masodik csoport egyben az utolso
            			csoportokSzama--;
            							// megszuntetjuk, hiszen foloslegesse valt
            		else
            			hossz[seged[2]] = 0; 
            							// kulonben, "kiuritjuk"			
       			}
	}
	
	int q = 0;							// kizarjuk az ures csoportokat
	for(int i = 1; i <= csoportokSzama; i++)
		if(hossz[i] != 0){	
			q++;
			hossz[q] = hossz[i];
			for(int j = 1; j <= hossz[q]; j++){
				cs[q][j] = cs[i][j];
			}
			halmazzaAlakit(hossz[q], cs[q]);
		}

	csoportokSzama = q;
}

void kiIrEredmeny(int k, int maxBaratok[], int parokSzama, int t, int mind[]){
// eredmenyek kiirasa

  	cout << "A legtobb barattal rendelkezo szemelyek (maxBaratok tomb): ";
  	kiIrSorozat(k, maxBaratok);
  
  	cout << "Szemelyek szama, akik kolcsonosen csak egymast jeloltek meg baratkent (parokSzama) = ";
  	cout << parokSzama << endl << endl;

  	cout << "A statisztikaban szereplo szemelyek (mind tomb): ";
  	kiIrSorozat(t, mind);
}

void kiIrCsoportok(int csoportokSzama, int hossz[], int cs[][maxDim]){

	cout << "Osszesen " << csoportokSzama << " csoport jott letre:" << endl;
	for(int i = 1; i <= csoportokSzama; i++){
		cout << i << ". csoport: ";
		for(int j = 1; j <= hossz[i]; j++)
			cout << cs[i][j] << " ";
		cout << endl;
	}
}

int main(){
par szemely[maxDim];			// szamparok sorozata (x megjelolte y-t, mint baratjat)
int maxBaratok[maxDim],
	baratokSzama[maxDim];		// legtobb barattal rendelkezo szemelyek sorozata
    
int n,							// szemelyek szama
    p,							// beolvasott szamparok darabszama
    k,							// legtobb barattal rendelkezo szemelyek szama
    parokSzama,					// szemelyek szama, akik kolcsonosen csak egymást jeloltek meg baratkent
    t,							// a statisztikaban szereplo szemelyek szama
    mind[maxDim];				// a statisztikaban szereplo szemelyek halmaza (sorozata)

  	beolvas(n, p, szemely);
  	kiIrBemenet(n, p, szemely);
    
  	maxBaratok_a(n, p, szemely, k, maxBaratok, baratokSzama);
  	parokSzama = parokSzama_b(n, p, szemely, baratokSzama);          
  	mind_c(n, p, szemely, t, mind);

  	kiIrEredmeny(k, maxBaratok, parokSzama, t, mind);

  	int csoportokSzama;
  	int hossz[maxDim];
  	int cs[maxDim][maxDim];
  	csoportosit(p, szemely, csoportokSzama, hossz, cs);

  	kiIrCsoportok(csoportokSzama, hossz, cs);
}
